package com.bpcl.lpg.core.dao.impl;

import de.hybris.platform.servicelayer.search.SearchResult;
import java.util.Collections;
import java.util.Objects;
import java.util.Map;
import de.hybris.platform.servicelayer.search.FlexibleSearchQuery;
import java.util.HashMap;
import java.util.List;
import com.bpcl.lpg.core.enums.GenericStatusEnum;
import java.util.Date;
import com.bpcl.lpg.core.dao.AutoPortabilityReqDao;
import com.bpcl.lpg.core.model.LpgAutoPortabilityModel;
import de.hybris.platform.servicelayer.internal.dao.DefaultGenericDao;

public class AutoPortabilityReqDaoImpl extends DefaultGenericDao<LpgAutoPortabilityModel> implements AutoPortabilityReqDao
{
    public AutoPortabilityReqDaoImpl(final String typecode) {
        super(typecode);
    }
    
    public List<LpgAutoPortabilityModel> getAutoPortabilityReqsByStatus(final Date startDate, final Date endDate, final GenericStatusEnum status) {
        final StringBuilder query = new StringBuilder("SELECT {ap.pk} from {").append("LpgAutoPortability").append(" as ap ").append("JOIN ").append("GenericStatusEnum").append(" as gse on {ap.").append("status").append("}={gse.pk}} ").append("WHERE {gse.code}=?").append("status").append(" AND {ap.").append("creationtime").append("}>= ?").append("startTime").append(" AND {ap.").append("creationtime").append("}<= ?").append("endTime");
        final Map<String, Object> param = new HashMap<String, Object>();
        param.put("status", status.getCode());
        param.put("startTime", startDate);
        param.put("endTime", endDate);
        final FlexibleSearchQuery flexibleSearchQuery = new FlexibleSearchQuery(query);
        flexibleSearchQuery.addQueryParameters((Map)param);
        final SearchResult<LpgAutoPortabilityModel> search = (SearchResult<LpgAutoPortabilityModel>)this.getFlexibleSearchService().search(flexibleSearchQuery);
        return Objects.isNull(search) ? Collections.emptyList() : search.getResult();
    }
}
